//+------------------------------------------------------------------+
//|                                                      MA_Tester   |
//|                                          Copyright 2012, Karlson |
//+------------------------------------------------------------------+
#property copyright "2012, Karlson."
#property link      "https://login.mql5.com/ru/users/Karlson"

input int MA=1000;
input int sls=100;
input int tps=100;

int ma_h=0;
double ma[];
MqlRates rat[];

#include <Trade\Trade.mqh>
CTrade send;

int KF=1,tries=0,allerror=0;

//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
{  
   ma_h=iMA(_Symbol,_Period,MA,0,MODE_SMA,PRICE_CLOSE);
   
   if(ma_h<0) { Print("  .");}
   
   if(_Digits==5 || _Digits==3) {KF=10;} else {KF=1;}
   
   ArrayInitialize(ma,0.0);
   
   send.SetDeviationInPoints(10*KF);
   
   if(GetLastError()>0) {Print(" OnInit",GetLastError());allerror++;return(-1);}
   
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  { ResetLastError();
    
    int bars=Bars(_Symbol,_Period);
    
    if(bars<MA+100) {Print("Bars=",bars);return;}
  
    double bid=SymbolInfoDouble(_Symbol,SYMBOL_BID);
    double ask=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
  
    int copy_r=CopyRates(_Symbol,_Period,0,2,rat);
    
    if (copy_r<2) {Print("  Rates.");return;}
    
    int copy_ma=CopyBuffer(ma_h,0,0,2,ma);
    
    if(copy_ma<2) {Print("  Ma.");return;} 
    
    if(PositionSelect(_Symbol)==0)
     
     {  
    
      if(rat[0].open<ma[0] && rat[0].close>ma[0]) { send.PositionOpen(_Symbol,ORDER_TYPE_BUY,1.0,ask,bid-sls*KF*_Point,bid+tps*KF*_Point,NULL);}
       
      if(rat[0].open>ma[0] && rat[0].close<ma[0]) { send.PositionOpen(_Symbol,ORDER_TYPE_SELL,1.0,bid,ask+sls*KF*_Point,ask-tps*KF*_Point,NULL);} 
    
     }
     
  
      
    if(GetLastError()>0 && GetLastError()!=4753) {Print(" OnTick",GetLastError());allerror++;;}
  }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
 {
  Print("Allerror=",allerror);
 }